/*
デッキが構築制限を満たすかどうかのチェックを行う
*/

// 炎天杯
function checkEnten(deck) {
    let cardList = deck.getCardList();
    if (cardList.length == 40) {
        let message = "";
        let okFlg = true;
        for (let i=0 ; i<40 ; i++) {
            let cardNo = cardList[i];
            // 禁止カードのチェック
            if (
                (cardNo == 175) ||  // 王の狩り
                (cardNo == 176) ||  // 魔物の香水
                (cardNo == 178) ||  // 守護天使の顕現
                (cardNo == 179) ||  // 恐怖公の召喚
                (cardNo == 180)     // 夜叉神の竜殺し
            ){
                okFlg = false;
                message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は禁止カードです\n'
            } else {
                // 独自ルールのチェック
                if (card_dict[cardNo]['category'] == 'ユニット') {
                    if (card_dict[cardNo]['attribute'] != '火') {
                        okFlg = false;
                        message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は火属性ではありません\n'
                    }
                }
            }
        }
        if (okFlg) {
            alert('チェック完了');
        } else {
            alert(message)
        }
    } else {
        alert("デッキが40枚ではありません");
        return;
    }
}

// 水面杯
function checkMinamo(deck) {
    let cardList = deck.getCardList();
    if (cardList.length == 40) {
        let message = "";
        let okFlg = true;
        for (let i=0 ; i<40 ; i++) {
            let cardNo = cardList[i];
            // 禁止カードのチェック
            if (
                (cardNo == 175) ||  // 王の狩り
                (cardNo == 176) ||  // 魔物の香水
                (cardNo == 177) ||  // 邪竜の襲来
                (cardNo == 178) ||  // 守護天使の顕現
                (cardNo == 179) ||  // 恐怖公の召喚
                (cardNo == 180)     // 夜叉神の竜殺し
            ){
                okFlg = false;
                message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は禁止カードです\n'
            } else {
                // 独自ルールのチェック
                if (card_dict[cardNo]['category'] == 'ユニット') {
                    if (card_dict[cardNo]['attribute'] != '水') {
                        okFlg = false;
                        message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は水属性ではありません\n'
                    }
                }
            }
        }
        if (okFlg) {
            alert('チェック完了');
        } else {
            alert(message)
        }
    } else {
        alert("デッキが40枚ではありません");
        return;
    }
}

// 地鎮杯
function checkJichin(deck) {
    let cardList = deck.getCardList();
    if (cardList.length == 40) {
        let message = "";
        let okFlg = true;
        for (let i=0 ; i<40 ; i++) {
            let cardNo = cardList[i];
            // 禁止カードのチェック
            if (
                (cardNo == 175) ||  // 王の狩り
                (cardNo == 176) ||  // 魔物の香水
                (cardNo == 177) ||  // 邪竜の襲来
                (cardNo == 178) ||  // 守護天使の顕現
                (cardNo == 180)     // 夜叉神の竜殺し
            ){
                okFlg = false;
                message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は禁止カードです\n'
            } else {
                // 独自ルールのチェック
                if (card_dict[cardNo]['category'] == 'ユニット') {
                    if (card_dict[cardNo]['attribute'] != '地') {
                        okFlg = false;
                        message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は地属性ではありません\n'
                    }
                }
            }
        }
        if (okFlg) {
            alert('チェック完了');
        } else {
            alert(message)
        }
    } else {
        alert("デッキが40枚ではありません");
        return;
    }
}

// 天祈杯
function checkTenki(deck) {
    let cardList = deck.getCardList();
    if (cardList.length == 40) {
        let message = "";
        let okFlg = true;
        for (let i=0 ; i<40 ; i++) {
            let cardNo = cardList[i];
            // 禁止カードのチェック
            if (
                (cardNo == 175) ||  // 王の狩り
                (cardNo == 177) ||  // 邪竜の襲来
                (cardNo == 178) ||  // 守護天使の顕現
                (cardNo == 179) ||  // 恐怖公の召喚
                (cardNo == 180) ||  // 夜叉神の竜殺し
                (cardNo == 208)     // 八卦の籠手
            ){
                okFlg = false;
                message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は禁止カードです\n'
            } else {
                // 独自ルールのチェック
                if (card_dict[cardNo]['category'] == 'ユニット') {
                    if (card_dict[cardNo]['attribute'] != '天') {
                        okFlg = false;
                        message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は天属性ではありません\n'
                    }
                }
            }
        }
        if (okFlg) {
            alert('チェック完了');
        } else {
            alert(message)
        }
    } else {
        alert("デッキが40枚ではありません");
        return;
    }
}

// 天臨杯
function checkTenrin(deck) {
    let cardList = deck.getCardList();
    if (cardList.length == 40) {
        let message = "";
        let okFlg = true;
        for (let i=0 ; i<40 ; i++) {
            let cardNo = cardList[i];
            // 禁止カードのチェック
            if (
                (cardNo == 176) ||  // 魔物の香水
                (cardNo == 177) ||  // 邪竜の襲来
                (cardNo == 179) ||  // 恐怖公の召喚
                (cardNo == 180) ||  // 夜叉神の竜殺し
                (cardNo == 208)     // 八卦の籠手
            ){
                okFlg = false;
                message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は禁止カードです\n'
            } else {
                // 独自ルールのチェック
                if (card_dict[cardNo]['category'] == 'ユニット') {
                    if (card_dict[cardNo]['attribute'] != '光') {
                        okFlg = false;
                        message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は光属性ではありません\n'
                    }
                }
            }
        }
        if (okFlg) {
            alert('チェック完了');
        } else {
            alert(message)
        }
    } else {
        alert("デッキが40枚ではありません");
        return;
    }
}

// 冥王杯
function checkMeiou(deck) {
    let cardList = deck.getCardList();
    if (cardList.length == 40) {
        let message = "";
        let okFlg = true;
        for (let i=0 ; i<40 ; i++) {
            let cardNo = cardList[i];
            // 禁止カードのチェック
            if (
                (cardNo == 175) ||  // 王の狩り
                (cardNo == 176) ||  // 魔物の香水
                (cardNo == 177) ||  // 邪竜の襲来
                (cardNo == 178) ||  // 守護天使の顕現
                (cardNo == 179) ||  // 夜叉神の竜殺し
                (cardNo == 208)     // 八卦の籠手
            ){
                okFlg = false;
                message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は禁止カードです\n'
            } else {
                // 独自ルールのチェック
                if (card_dict[cardNo]['category'] == 'ユニット') {
                    if (card_dict[cardNo]['attribute'] != '闇') {
                        okFlg = false;
                        message += '[' + i + ']' + card_dict[cardNo]['name'] + 'は闇属性ではありません\n'
                    }
                }
            }
        }
        if (okFlg) {
            alert('チェック完了');
        } else {
            alert(message)
        }
    } else {
        alert("デッキが40枚ではありません");
        return;
    }
}